<script lang="ts">
    /**
     * The panel with information and actions about the selected field.
     */
    import { createEventDispatcher, onMount } from 'svelte'
    import type { Writable } from 'svelte/store'
    import Level from './FieldPanel/Building/Level.svelte'
    import ProductionSummary from './FieldPanel/Building/ProductionSummary.svelte'
    import StorageSummary from './FieldPanel/Building/StorageSummary.svelte'
    import BuildingFooter from './FieldPanel/Building/Footer.svelte'
    import UpgradeCost from './FieldPanel/UpgradeCost.svelte'
    import Button from './FieldPanel/Footer/Button.svelte'
    import AvailableBuildings from './FieldPanel/AvailableBuildings.svelte'
    import type DistrictField from '$models/DistrictField'
    import type District from '$models/District'
    import type Building from '$models/Building'
    import type Tile from '$lib/map/Tile'
    import StarshipyardSummary from './FieldPanel/Building/StarshipyardSummary.svelte'

    export let district: District
    export let tile: Tile
    let field: DistrictField
    $: field = tile.districtField

    let building: Building
    let apiHydrated: Writable<boolean>

    onMount(async () => {
        if (!field || !field.isBuilding()) {
            if (field) building = null
            return
        }
        building = field
        apiHydrated = building.apiHydrated
        if ($apiHydrated) return
        await building.hydrate()
    })

    const dispatch = createEventDispatcher()
    const cancel = () => {
        dispatch('cancel')
    }

    const demolish = () => {
        field.demolish().then(() => {
            field = null
            cancel()
            window.location.reload()
        })
    }
</script>

<main>
    <div class="body">
        {#if field === null}
            <AvailableBuildings on:newBuilding />
        {:else}
            <header>
                <h2>{field.name()}</h2>
                {#if building}
                    <Level {building} />
                {/if}

                <p class="description">
                    {field.description}
                </p>
            </header>

            {#if $apiHydrated && building.isStorage()}
                <StorageSummary {building} />
            {:else if $apiHydrated && building.isProduction()}
                <ProductionSummary {building} />
            {:else if $apiHydrated && building.isStarshipyard()}
                <StarshipyardSummary {building} />
            {/if}

            {#if building && $apiHydrated}
                <UpgradeCost {building} />
            {/if}
        {/if}
    </div>
    <footer>
        {#if building}
            <BuildingFooter bind:building {district} />
        {/if}
        <div class="buttons">
            {#if building === null || (building && building.constructor.name !== 'DistrictCouncil' && building.level)}
                <Button variant="demolish" on:click={demolish}>Demolish</Button>
            {/if}
            <Button variant="cancel" on:click={cancel}>Quit</Button>
        </div>
    </footer>
</main>

<style lang="postcss">
    main {
        @apply h-full flex flex-col p-4 pt-6 pr-10
        text-trueGray-900 dark:text-trueGray-50 overflow-auto;

        .body {
            @apply flex-1;

            header {
                @apply mb-4 px-6 py-4
                bg-gradient-to-r from-fuchsia-200 to-indigo-200
                dark:from-fuchsia-900 dark:to-indigo-900;
                clip-path: polygon(98.5% 0, 100% 100%, 1.5% 100%, 0 0);

                h2 {
                    @apply font-semibold text-2xl;
                }

                .description {
                    @apply mt-2;
                }
            }
        }

        footer {
            @apply grid gap-1 mt-auto;

            .buttons {
                @apply flex gap-x-2;

                & > :global(button) {
                    @apply w-full;

                    &:not(:only-child) {
                        @apply w-1/2;
                    }
                }
            }
        }
    }
</style>
